searchNodes=[{"doc":"Skewheap - a mergable priority queue Skewheaps are fun, weird, priority queues that self-balance over time. Their structural depth is not guaranteed and individual operations may vary in performance. That said, its amortized performance is roughly O(log n) ( source ). Skewheaps' most interesting characteristic is that they can be very quickly merged together non-destructively, creating a new, balanced heap containing all elements of the source heaps. Examples iex&gt; { _skew , items } = 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . drain ( ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 ] iex&gt; a = 1 .. 3 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; b = 4 .. 6 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; { _skew , items } = Skewheap . merge ( a , b ) |&gt; Skewheap . drain ( ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 , 6 ]","ref":"Skewheap.html","title":"Skewheap","type":"module"},{"doc":"Removes all elements from the heap and returns them as a list. Examples iex&gt; { _skew , items } = 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . drain ( ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 ]","ref":"Skewheap.html#drain/1","title":"Skewheap.drain/1","type":"function"},{"doc":"Removes up to count elements from the heap and returns them as a list. Examples iex&gt; { _skew , items } = 1 .. 5 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . drain ( ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 ] iex&gt; { _skew , items } = 1 .. 5 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . drain ( 3 ) ...&gt; items [ 1 , 2 , 3 ] iex&gt; { _skew , items } = 1 .. 5 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . drain ( 5 ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 ]","ref":"Skewheap.html#drain/2","title":"Skewheap.drain/2","type":"function"},{"doc":"","ref":"Skewheap.html#drain/3","title":"Skewheap.drain/3","type":"function"},{"doc":"True when the Skewheap has no items in it. Examples iex&gt; Skewheap . new ( ) |&gt; Skewheap . empty? ( ) true iex&gt; 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . empty? ( ) false","ref":"Skewheap.html#empty?/1","title":"Skewheap.empty?/1","type":"macro"},{"doc":"Fills the heap with a list of items. Examples iex&gt; {_skew, items} = Skewheap.fill(Skewheap.new(), 1..5 |&gt; Enum.shuffle()) |&gt; Skewheap.drain() ...&gt; items [1, 2, 3, 4, 5]","ref":"Skewheap.html#fill/2","title":"Skewheap.fill/2","type":"function"},{"doc":"Returns true if element is present in the skewheap. Note that this requires a depth first search of the binary heap structure. Examples iex&gt; s = 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; Skewheap . member? ( s , 5 ) true iex&gt; s = 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; Skewheap . member? ( s , 15 ) false iex&gt; Skewheap . member? ( Skewheap . new ( ) , 42 ) false","ref":"Skewheap.html#member?/2","title":"Skewheap.member?/2","type":"function"},{"doc":"Merges two skew heaps into a new heap. Examples iex&gt; a = 1 .. 3 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; b = 4 .. 6 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) ...&gt; { _skew , items } = Skewheap . merge ( a , b ) |&gt; Skewheap . drain ( ) ...&gt; items [ 1 , 2 , 3 , 4 , 5 , 6 ]","ref":"Skewheap.html#merge/2","title":"Skewheap.merge/2","type":"function"},{"doc":"Returns a new Skewheap. Examples iex&gt; Skewheap . new ( ) |&gt; Skewheap . size ( ) 0 iex&gt; Skewheap . new ( ) |&gt; Skewheap . empty? ( ) true","ref":"Skewheap.html#new/1","title":"Skewheap.new/1","type":"function"},{"doc":"Returns the top element of the heap without removing it or :nothing if empty. Examples iex&gt; 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . peek ( ) 1 iex&gt; Skewheap . new ( ) |&gt; Skewheap . peek ( ) :nothing","ref":"Skewheap.html#peek/1","title":"Skewheap.peek/1","type":"function"},{"doc":"Adds a new element to the heap. Examples iex&gt; s = Skewheap . new ( ) ...&gt; s = Skewheap . put ( s , 42 ) ...&gt; Skewheap . put ( s , &quot;fnord&quot; ) ...&gt; Skewheap . peek ( s ) 42","ref":"Skewheap.html#put/2","title":"Skewheap.put/2","type":"function"},{"doc":"Returns the number of items in the Skewheap. Examples iex&gt; Skewheap . new ( ) |&gt; Skewheap . size ( ) 0 iex&gt; 1 .. 10 |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . size ( ) 10","ref":"Skewheap.html#size/1","title":"Skewheap.size/1","type":"function"},{"doc":"Retrieves the top element from the heap or :nothing if empty. Examples iex&gt; { _skew , value } = Skewheap . new ( ) |&gt; Skewheap . take ( ) ...&gt; value :nothing iex&gt; { skew , value } = [ 1 , 2 , 3 ] |&gt; Enum . shuffle ( ) |&gt; Enum . into ( Skewheap . new ( ) ) |&gt; Skewheap . take ( ) ...&gt; { value , Skewheap . size ( skew ) } { 1 , 2 }","ref":"Skewheap.html#take/1","title":"Skewheap.take/1","type":"function"},{"doc":"","ref":"Skewheap.html#t:t/0","title":"Skewheap.t/0","type":"type"}]